<?php

function getHoraireEtat($energie, $date){
	if(is_null($energie) || empty($energie)){
		$energie = 'Gaz';
	}
	if(is_null($date) || empty($date)){
		$date = date('Y-m-d');
	}
	$chauffageEtatHoraire = array();
	$query = "select DATE_FORMAT(date,'%H') as heure ,DATE_FORMAT(date,'%i') as minute ,etat from chauffage_etat where energie = '".$energie."' and DATE_FORMAT(date,'%Y-%m-%d') = '".$date."' order by date ASC";	
	$res_query = exec_query($query);
	while ($row = mysql_fetch_assoc($res_query)) {
   		$chauffageEtatHoraire[] = $row;      		
	}
	return($chauffageEtatHoraire);
}

function affichGraphChauffage($chauffageEtatHoraire, $color='FF0000',$date=null, $calendrier=null){	
	global $largeurEcran;
	if(count($chauffageEtatHoraire) > 0){
		$etatInit = 1;
		if($chauffageEtatHoraire[0]['etat'] == 1){
			$etatInit = 0;
		}	
	}else{
		return;
	}
	if(is_null($date)){
		$date= date('Y-m-d');
	}
	$jDate = null;
	if(!is_null($calendrier) && is_array($calendrier)){		  
		 $tDate = strtotime($date);
		 $jDate = date('N', $tDate);		 
	}
	$cptHoraire = 0;	
	echo '<table border="0" cellpadding="0" cellspacing="0" width="'.$largeurEcran.'">';
	echo '<tr>';	
	for($heure=0;$heure<24;$heure++){		
		$title = $heure."h";
		if(!is_null($jDate) && $calendrier[$jDate][$heure] == 1){
			//echo '<td bgcolor="FF9999">';
			echo '<td id="tdConfort">';
		}else{		
			//echo '<td bgcolor="9999FF">';
			echo '<td id="tdEco">';
		}		
		$graphEtat = array();				
		for($minute=0;$minute<60;$minute++){			
			if((int)($chauffageEtatHoraire[$cptHoraire]['heure']) == $heure && (int)($chauffageEtatHoraire[$cptHoraire]['minute']) == $minute){
				$etatInit = $chauffageEtatHoraire[$cptHoraire]['etat'];
				$cptHoraire++;
			}
			if($date == date('Y-m-d') && $heure.$minute > date('Hi')){
				$etatInit = 0;				
			}
			$graphEtat[] = $etatInit*100;;	
		}
		echo '<img src="http://chart.apis.google.com/chart?chbh=a,0,0&chs=60x30&cht=bvs&chts=676767,0&chco='.$color.'&chd=t:'.implode(",",$graphEtat).'&chtt='.$title.'" width="60" height="30"/>';
		echo '<br>'.$title.'</td>';
		if((int)(($heure+1)%12)==0){
			echo '</tr><tr>'; 	
		} 
	}
	echo '</tr>';
	echo '</table>';
}

function calculTempsOn($chauffageEtatHoraire, $date=null){
	if(is_null($date)){
		$date= date('Y-m-d');
	}
	$tempsOn = 0;
	$result['minute']='0';
	$result['txt']='0 mn';
	if(count($chauffageEtatHoraire) > 0){
		$i=0;
		$nb = count($chauffageEtatHoraire);
		if($chauffageEtatHoraire[0]['etat'] == 0){
			/**
			 * Le chauffage a été allumé avant minuit, il faut donc partir de minuit jusqu a cet evenement 
			 */
			$tempsOn = (int)($chauffageEtatHoraire[0]['heure'])*60 + (int)($chauffageEtatHoraire[0]['minute']);
			$i=1; 	
		}
		
		if($chauffageEtatHoraire[$nb-1]['etat'] == 1){
			/**
			 * Le chauffage est resté allumé apres minuit minuit ou jusqu'a l'heure actuel qi nous sommes aujourd'hui 
			 */
			if($date == date('Y-m-d')){
				$tempsOn += ((int)date('H')-(int)($chauffageEtatHoraire[$nb-1]['heure']))*60 + (date('i')-(int)($chauffageEtatHoraire[$nb-1]['minute']));			
				$nb=$nb-1;
			}
			if($date < date('Y-m-d')){
				$tempsOn += (23-(int)($chauffageEtatHoraire[$nb-1]['heure']))*60 + (60-(int)($chauffageEtatHoraire[$nb-1]['minute']));
				$nb=$nb-1;
			} 	
		}
		
		for($i;$i<$nb;$i){	
			if($i+1 <$nb){
				$tempsOn += ((int)($chauffageEtatHoraire[$i+1]['heure'])-(int)($chauffageEtatHoraire[$i]['heure']))*60 + ((int)($chauffageEtatHoraire[$i+1]['minute'])-(int)($chauffageEtatHoraire[$i]['minute']));			
			}
			$i=$i+2;
		}
		
		$result['minute'] = $tempsOn;
		if($tempsOn < 60){
			$result['txt'] = $tempsOn.' mn';
		}else{
			$result['txt'] = (int)($tempsOn/60).' h '.($tempsOn%60).' mn';
		}				
	}
	return $result;
}

function showGraphTemp($date, $zones, $colorZones){
	global $largeurEcran;
	$pas = 30;
	$heureInit = '00:00:00';
	$temperatures = array();
	$tempMax = -1000;
	$tempMin = 1000;
	foreach($zones as $zone){
		$tempZoneMax = -1000;
		$tempZoneMin = 1000;
		$query = "select * from temperature where zone = '".$zone."' and DATE_FORMAT(date,'%Y-%m-%d') = '".$date."' order by date ASC";
		$res_query = exec_query($query);
		while ($row = mysql_fetch_assoc($res_query)) {
			if($row['temp'] > $tempMax) $tempMax = $row['temp'];
			if($row['temp'] < $tempMin) $tempMin = $row['temp'];
			
			if($row['temp'] > $tempZoneMax) $tempZoneMax = $row['temp'];
			if($row['temp'] < $tempZoneMin) $tempZoneMin = $row['temp'];
			
			$temperatures[$zone][$row['date']] = $row['temp'];
			$temp= $row['temp'];     		
		}
		$temperatures[$zone]['now'] = $temp;
		$temperatures[$zone]['min'] = $tempZoneMin;
		$temperatures[$zone]['max'] = $tempZoneMax;
	}
	
	for($i=0;$i<(24*60);){
		$heure = $dateCalcul = date('Y-m-d H:i:s', mktime(0, $i, 0, date("m")  , date("d"), date("Y")));
		foreach($zones as $zone){
			if(isset($temperatures[$zone][$heure]) && !empty($temperatures[$zone][$heure])){
				$temperatures[$zone]['datas'][] = $temperatures[$zone][$heure];
			}else{
				$temperatures[$zone]['datas'][] = 0;
			}
		}
		$i=$i+$pas;
	}
	
	$tempMin = $tempMin - 0.1;
	$datasTxt = "";
	$minMaxTxt = "";
	$tempActuellesTxt = "";
	$datasZone = array();
	$minMax = array();
	foreach($zones as $zone){
		$minMax[] = $tempMin.",".$tempMax.",".$tempMin.",".$tempMax;
		$datasZone[] = implode(",",$temperatures[$zone]['datas']);
		$zonesTxt[] = strtoupper($zone)." : ".$temperatures[$zone]['now']." / ".$temperatures[$zone]['min']." / ".$temperatures[$zone]['max']."&deg;C"; 
	}
	$datasTxt = implode("|-1|",$datasZone);
	$minMaxTxt = implode(",",$minMax);
	echo "<br>".$tempTxt."<br>";

	echo '<img src="http://chart.apis.google.com/chart?chxr=0,0,24|1,'.$tempMin.','.$tempMax.'&chs='.$largeurEcran.'x100&cht=lxy&chco='.implode(",",$colorZones).'&chds='.$minMaxTxt.'&chd=t:-1|'.$datasTxt.'&chdl='.implode("|",$zonesTxt).'&chdlp=b&chls=2|2|2|2&chma=5,5,5,25|0,40" width="'.$largeurEcran.'" height="100"/>';
}

function afficheEtat($energie){
	$retour = "";
	$query = "select * from chauffage_etat where energie = '".$energie."' order by date DESC limit 0,1";
	$res_query = exec_query($query);
	if(mysql_numrows($res_query) > 0){	 
		$etat = mysql_result($res_query,0,"etat");		
		$etatDate = mysql_result($res_query,0,"date");	
	}
	$etatTxt = "vert";
	if($etat == '1'){
		$etatTxt = "rouge";
	}
	if($energie == 'Gaz'){
		$retour = '<div class="'.$etatTxt.'">Chaudière</div>';
	}
	if($energie == 'Elec'){
		$retour = '<div class="'.$etatTxt.'">Radiateurs</div>';
	}
	return $retour;
}

function showDayGraphTemp($zones, $colorZones){
	global $largeurEcran;
	$zoneValues = array('min', 'moy', 'max');
	$dateInit = date('Y-m-d', mktime(0, 0, 0, date("m")  , date("d")-30, date("Y")));
	$heureInit = '00:00:00';
	$temperatures = array();
	$tempMax = -1000;
	$tempMin = 1000;
	foreach($zones as $zone){
		$tempZoneMax = -1000;
		$tempZoneMin = 1000;
		$query = "select * from temperature_stats where zone = '".$zone."' and date > '".$date."' order by date ASC";
		$res_query = exec_query($query);
		while ($row = mysql_fetch_assoc($res_query)) {
			if($row['temp_max'] > $tempMax) $tempMax = $row['temp_max'];
			if($row['temp_min'] < $tempMin) $tempMin = $row['temp_min'];
			
			if($row['temp_max'] > $tempZoneMax) $tempZoneMax = $row['temp_max'];
			if($row['temp_min'] < $tempZoneMin) $tempZoneMin = $row['temp_min'];
			
			$temperatures[$zone]['max'][$row['date']] = $row['temp_max'];
			$temperatures[$zone]['moy'][$row['date']] = $row['temp_moy'];
			$temperatures[$zone]['min'][$row['date']] = $row['temp_min'];
			$temp= $row['temp'];     		
		}
		$temperatures[$zone]['minValue'] = $tempZoneMin;
		$temperatures[$zone]['maxValue'] = $tempZoneMax;
	}
	
	for($i=0;$i<30;$i++){
		$jour = $dateCalcul = date('Y-m-d', mktime(0, 0, 0, date("m")  , date("d")+$i-30, date("Y")));
		foreach($zones as $zone){
			foreach($zoneValues as $zoneValue){
				if(isset($temperatures[$zone][$zoneValue][$jour]) && !empty($temperatures[$zone][$zoneValue][$jour])){
					$temperatures[$zone][$zoneValue]['datas'][] = $temperatures[$zone][$zoneValue][$jour];
				}else{
					$temperatures[$zone][$zoneValue]['datas'][] = 0;
				}	
			}
		}
	}

	$tempMin = $tempMin - 0.1;
	$datasTxt = "";
	$minMaxTxt = "";
	$tempActuellesTxt = "";
	$datasZone = array();
	$minMax = array();
	foreach($zones as $zone){
		foreach($zoneValues as $zoneValue){
			$minMax[] = $tempMin.",".$tempMax.",".$tempMin.",".$tempMax;
			$datasZone[] = implode(",",$temperatures[$zone][$zoneValue]['datas']); 
		}
		$zonesTxt[] = strtoupper($zone)." : ".$temperatures[$zone]['minValue']." / ".$temperatures[$zone]['maxValue']."&deg;C";
	}
	
	$colorZonesDetail = array();
	$colorZonesStyle = array();
	foreach($colorZones as $colorZone){
		foreach($zoneValues as $zoneValue){
			$colorZonesDetail[] = $colorZone;
			if($zoneValue == 'max') $colorZonesStyle[] = '1,2,2';
			if($zoneValue == 'moy') $colorZonesStyle[] = '2';
			if($zoneValue == 'min') $colorZonesStyle[] = '1,2,2';
		}	
	}
	
	$datasTxt = implode("|-1|",$datasZone);
	$minMaxTxt = implode(",",$minMax);

	echo '<img src="http://chart.apis.google.com/chart?chxr=0,0,24|1,'.$tempMin.','.$tempMax.'&chs='.$largeurEcran.'x100&cht=lxy&chco='.implode(",",$colorZonesDetail).'&chds='.$minMaxTxt.'&chd=t:-1|'.$datasTxt.'&chdl='.implode("|",$zonesTxt).'&chdlp=b&chls='.implode("|",$colorZonesStyle).'&chma=5,5,5,25|0,40" width="'.$largeurEcran.'" height="100"/>';
}

?>
