<?php
/**
 * Tableau contenant les éléments de configuration
 * @global	array	$client_config
 */
$client_config = array();
$GLOBALS['soft_config'] = $client_config;
$GLOBALS['client_config'] = $client_config;


$client_config['emailMethod']		= 'smtp';			// mail|sendmail|smtp
$client_config['emailSmtpHost']		= 'localhost'; // 
$client_config['emailSmtpDebug']	= false;			// smtp en mode debug
$client_config['emailSmtpUser']		= '';				// 'serviceclients';
$client_config['emailSmtpPwd']		= '';				// 'LOGIN.next';

$client_config['prefixe_DB']		= "";		// prefixe des tables de l'appli

/**
 * Configuration des constantes du site en fonction des environements d'exécution
 * 
 * Récupération de l'adresse IP du serveur 
 * afin de reconnaitre l'environement dans 
 * lequel le script s'execute
 */

switch ($_SERVER['SERVER_ADDR']) {

	// Environement LOCAL
	case "127.0.0.1":
	error_reporting(E_ALL ^ E_NOTICE);
	$client_config['cookie_domain']		= "localhost";	
	$client_config['emailSmtpHost']		= ""; 								//  serveur smtp
	$client_config['debugMode']			= true;
	$client_config['dbDriver']			= "mysql";							// driver utilisé pour la connexion
	$client_config['dbServer']			= "localhost";						// serveur de bases de données
	$client_config['dbLogin']			= "root";							// login du serveur de bases de données
	$client_config['dbPwd']				= "";								// mot de passe du serveur de bases de données
	$client_config['dbName']			= "zibase";							// nom de la base de données
	$client_config['basePath']			= "C:/wamp/www/zibase/";			// racine du système
	$client_config['siteUrl']			= "http://localhost/zibase/";		// url d'accès au site
	$client_config['siteName']			= "zibase DEV";						// nom du site
	break;
	
	// environement de PROD
	case "xxx.xxx.xxx.xxx": 
	error_reporting(E_ALL ^ E_NOTICE);
	$client_config['cookie_domain']		= "";	
	$client_config['emailSmtpHost']		= ""; 					//  serveur smtp
	$client_config['debugMode']			= true;
	$client_config['dbDriver']			= "mysql";				// driver utilisé pour la connexion
	$client_config['dbServer']			= "";					// serveur de bases de données
	$client_config['dbLogin']			= "";					// login du serveur de bases de données
	$client_config['dbPwd']				= "";					// mot de passe du serveur de bases de données
	$client_config['dbName']			= "";					// nom de la base de données
	$client_config['basePath']			= "";					// racine du système
	$client_config['siteUrl']			= "";					// url d'accès au site
	$client_config['siteName']			= "zibase PROD";		// nom du site
	break;
			
	// default
	default:
	echo "<br>Adresse IP du serveur : ".$_SERVER['SERVER_ADDR'];
	echo "<br>Chemin du serveur : ".$_SERVER["DOCUMENT_ROOT"];		
	die("<br>Probleme de config");
	break;
}

$client_config['charset']		= 'UTF-8';
$client_config['dbCharset']		= 'UTF8';

$soft_config = $client_config;


?>