<?php
include_once('./include/include.php');
include('./include/connect_db.php');
include('./include/chauffage.inc.php');
setlocale(LC_TIME, 'fr_FR', 'fra_FRA');
date_default_timezone_set ( "Europe/Brussels" );

include('./header.inc.php');


$calendrier = array();

for($jour=1;$jour<=7;$jour++){
	// pour chaque jour de la semaine
	for($heure=0;$heure<24;$heure++){
		// pour chaque heure
		$calendrier[$jour][$heure] = 0 ; // mode �co
	}
}
// definition des plages de confort
// 1 pour lundi
// matin soir de semaine
$jours = array(1,2,3,4,5);
foreach($jours as $jour){
	$calendrier[$jour][5] = 1 ;
	$calendrier[$jour][6] = 1 ;
	$calendrier[$jour][7] = 1 ;	
	$calendrier[$jour][18] = 1 ;
	$calendrier[$jour][19] = 1 ;
	$calendrier[$jour][20] = 1 ;
	$calendrier[$jour][21] = 1 ;
	$calendrier[$jour][22] = 1 ;
}

// mercredi et WE
$jours = array(3,6,7);
foreach($jours as $jour){
	$calendrier[$jour][6] = 1 ;
	$calendrier[$jour][7] = 1 ;	
	$calendrier[$jour][8] = 1 ;
	$calendrier[$jour][9] = 1 ;
	$calendrier[$jour][10] = 1 ;
	$calendrier[$jour][11] = 1 ;
	$calendrier[$jour][12] = 1 ;
	$calendrier[$jour][13] = 1 ;
	$calendrier[$jour][14] = 1 ;
	$calendrier[$jour][15] = 1 ;
	$calendrier[$jour][16] = 1 ;
	$calendrier[$jour][17] = 1 ;
	$calendrier[$jour][18] = 1 ;
	$calendrier[$jour][19] = 1 ;
	$calendrier[$jour][20] = 1 ;
	$calendrier[$jour][21] = 1 ;
	$calendrier[$jour][22] = 1 ;
}

// mardi jeudi : Teletravail
$jours = array(2,4);
foreach($jours as $jour){
	$calendrier[$jour][11] = 1 ;
	$calendrier[$jour][12] = 1 ;	
	$calendrier[$jour][13] = 1 ;
}

// recuperation de la plage en cours 
$jour = date('N');
$heure = (int)(date('H'));
switch($calendrier[$jour][$heure]){
	case 0:
		$phaseEnCours = "Absent/Nuit";
	break;
	
	case 1:
		$phaseEnCours = "Confort";
	break;
}

$largeurEcran = 720;


if(isset($_GET['date'])  && !empty($_GET['date'])){
	$date = $_GET['date'];
}else{
	$date = date('Y-m-d');	
}

//$date = '2010-10-27';
$chaudiereEtatHoraire = getHoraireEtat('Gaz',$date);
$radiateurEtatHoraire = getHoraireEtat('Elec',$date);

$dureeGazOn = calculTempsOn($chaudiereEtatHoraire,$date);
$dureeElecOn = calculTempsOn($radiateurEtatHoraire,$date);

?>
<table border="1" cellpadding="0" cellspacing="0" width="<?php echo $largeurEcran; ?>">
<tr>
	<td align="center"><?php echo date("D d/m/Y H:i:s");?></td>
	<td align="center"><?php echo $phaseEnCours; ?></td>
	<td align="center"><?php echo afficheEtat('Gaz');?></td>
	<td align="center"><?php echo afficheEtat('Elec');?></td>
</tr>
</table>
<br>
<table border="1" cellpadding="0" cellspacing="0" width="<?php echo $largeurEcran; ?>">
<tr>
	<td align="center">Chaudi&egrave;re &agrave; gaz <?php echo $dureeGazOn['txt']; ?> / journ&eacute;e</td>
</tr>
<tr>
	<td><?php affichGraphChauffage($chaudiereEtatHoraire,'FF9999',$date, $calendrier);?></td>
</tr>
</table>
<br>
<table border="1" cellpadding="0" cellspacing="0" width="<?php echo $largeurEcran; ?>">
<tr>
	<td align="center">Radiateurs Electriques <?php echo $dureeElecOn['txt']; ?> / journ&eacute;e</td>
</tr>
<tr>
	<td><?php affichGraphChauffage($radiateurEtatHoraire,'FF9999',$date, $calendrier);?></td>
</tr>
</table>
</br>

<?php 
showGraphTemp($date, array('sdb', 'hugo', 'salon'), array('FF0000','FF9900','80C65A'));
echo "<br>";
showGraphTemp($date, array('dehors'), array('FF00FF'));


$jours= array();

$maxElec = 0;
$maxGaz = 0;

$query = "select * from chauffage_stats where energie = 'Gaz' and date >= '".date('Y-m-d', mktime(0, 0, 0, date("m")  , date("d") - 30, date("Y")))."'";
$res_query = exec_query($query);
while ($row = mysql_fetch_assoc($res_query)) {
   	if($row['duree_on'] > $maxGaz){
   		$maxGaz = $row['duree_on'];
   	}
	$dureeJourGaz[$row['date']] = $row['duree_on'];      		
}
$query = "select * from chauffage_stats where energie = 'Elec' and date >= '".date('Y-m-d', mktime(0, 0, 0, date("m")  , date("d") - 30, date("Y")))."'";
$res_query = exec_query($query);
while ($row = mysql_fetch_assoc($res_query)) {   
	if($row['duree_on'] > $maxElec){
   		$maxElec = $row['duree_on'];
   	}
	$dureeJourElec[$row['date']] = $row['duree_on'];      		
}
$max = $maxElec;
if($maxGaz > $maxElec ){
	$max = $maxGaz;	
}

for($i=30;$i>0;$i--){
	$dateCalcul = date('Y-m-d', mktime(0, 0, 0, date("m")  , date("d") - $i, date("Y")));	
	$jours[$dateCalcul]['Gaz'] = 0;
	$jours[$dateCalcul]['Elec'] = 0;
	if(isset($dureeJourGaz[$dateCalcul])){	
		$jours[$dateCalcul]['Gaz'] = $dureeJourGaz[$dateCalcul];
	}
	if(isset($dureeJourElec[$dateCalcul])){
		$jours[$dateCalcul]['Elec'] = $dureeJourElec[$dateCalcul];
	}
}

$valeurs = "";
foreach($jours as $jour){
	$valeursGaz[] = $jour['Gaz'];
	$valeurselec[] = $jour['Elec'];
}
$valeurs = implode(",",$valeursGaz)."|".implode(",",$valeurselec);
?>
</br>
<img src="http://chart.apis.google.com/chart?chxl=1:|test|test2|test3&chxp=1,25,2,10&chxr=0,0,<?php echo $max; ?>&chds=0,<?php echo $max; ?>,0,<?php echo $max; ?>&chxt=y,x&chbh=a,0&chs=<?php echo $largeurEcran; ?>x150&cht=bvg&chco=FF9900,3072F3&chd=t:<?php echo $valeurs; ?>&chtt=30+derniers+jours" width="<?php echo $largeurEcran; ?>" height="150"/>
<meta http-equiv="refresh" content="300;url=<?php echo $_SERVER['PHP_SELF'].'?'.$_SERVER['QUERY_STRING'];?>">
<?php 

//showDayGraphTemp(array('sdb', 'hugo', 'salon'), array('FF0000','FF9900','80C65A'));
showDayGraphTemp(array('sdb'), array('FF0000'));
showDayGraphTemp(array('hugo'), array('FF9900'));
showDayGraphTemp(array('salon'), array('80C65A'));
showDayGraphTemp(array('dehors'), array('FF00FF'));

include('./footer.inc.php');
?>
